UNCLASSIFIED
Skip to content
GitLab
Projects
Groups
Snippets
Help
Loading...
Help
Help
Support
Community forum
Keyboard shortcuts
?
Submit feedback
Sign in
Toggle navigation
Open sidebar
Ironbank Containers
Bitnami
airflow-worker
Commits
72864b0e
Commit
72864b0e
authored
Apr 13, 2021
by
Austin Denton
Committed by
Vickie Shen
Apr 13, 2021
Browse files
Sato 66
parent
37db64f6
Changes
28
Expand all
Hide whitespace changes
Inline
Side-by-side
Showing
20 changed files
with
2783 additions
and
2 deletions
+2783
-2
Dockerfile
Dockerfile
+68
-0
LICENSE
LICENSE
+13
-0
README.md
README.md
+480
-2
hardening_manifest.yaml
hardening_manifest.yaml
+77
-0
prebuildfs/opt/bitnami/.bitnami_components.json
prebuildfs/opt/bitnami/.bitnami_components.json
+44
-0
prebuildfs/opt/bitnami/licenses/licenses.txt
prebuildfs/opt/bitnami/licenses/licenses.txt
+3
-0
prebuildfs/opt/bitnami/scripts/libbitnami.sh
prebuildfs/opt/bitnami/scripts/libbitnami.sh
+51
-0
prebuildfs/opt/bitnami/scripts/libcomponent.sh
prebuildfs/opt/bitnami/scripts/libcomponent.sh
+65
-0
prebuildfs/opt/bitnami/scripts/libfile.sh
prebuildfs/opt/bitnami/scripts/libfile.sh
+80
-0
prebuildfs/opt/bitnami/scripts/libfs.sh
prebuildfs/opt/bitnami/scripts/libfs.sh
+183
-0
prebuildfs/opt/bitnami/scripts/libhook.sh
prebuildfs/opt/bitnami/scripts/libhook.sh
+16
-0
prebuildfs/opt/bitnami/scripts/liblog.sh
prebuildfs/opt/bitnami/scripts/liblog.sh
+112
-0
prebuildfs/opt/bitnami/scripts/libnet.sh
prebuildfs/opt/bitnami/scripts/libnet.sh
+142
-0
prebuildfs/opt/bitnami/scripts/libos.sh
prebuildfs/opt/bitnami/scripts/libos.sh
+350
-0
prebuildfs/opt/bitnami/scripts/libpersistence.sh
prebuildfs/opt/bitnami/scripts/libpersistence.sh
+122
-0
prebuildfs/opt/bitnami/scripts/libservice.sh
prebuildfs/opt/bitnami/scripts/libservice.sh
+235
-0
prebuildfs/opt/bitnami/scripts/libvalidations.sh
prebuildfs/opt/bitnami/scripts/libvalidations.sh
+248
-0
prebuildfs/opt/bitnami/scripts/libversion.sh
prebuildfs/opt/bitnami/scripts/libversion.sh
+49
-0
prebuildfs/opt/bitnami/scripts/libwebserver.sh
prebuildfs/opt/bitnami/scripts/libwebserver.sh
+421
-0
prebuildfs/usr/sbin/install_packages
prebuildfs/usr/sbin/install_packages
+24
-0
No files found.
Dockerfile
0 → 100644
View file @
72864b0e
ARG
BASE_REGISTRY=registry1.dsop.io
ARG
BASE_IMAGE=ironbank/redhat/ubi/ubi8
ARG
BASE_TAG=8.3
FROM
bitnami/airflow-worker:2.0.1-debian-10-r54 as base
FROM
${BASE_REGISTRY}/${BASE_IMAGE}:${BASE_TAG}
ARG
BITNAMI_HOME=/opt/bitnami
ARG
BITNAMI_DIR=/bitnami
ENV
BITNAMI_PKG_EXTRA_DIRS="/opt/bitnami/airflow/dags" \
HOME="/" \
OS_ARCH="amd64" \
OS_FLAVOUR="debian-10" \
OS_NAME="linux"
COPY
--from=base ${BITNAMI_HOME} ${BITNAMI_HOME}
COPY
--from=base ${BITNAMI_DIR} ${BITNAMI_DIR}
COPY
--from=base \
/lib/x86_64-linux-gnu/libbz2.so.1.0 \
/usr/lib64/
COPY
prebuildfs /
RUN
dnf update
-y
--nodocs
&&
\
dnf
install
-y
curl
tar gzip
ca-certificates libxml2 procps glibc-langpack-en
&&
\
dnf clean all
&&
\
rm
-rf
/var/cache/dnf
&&
\
mkdir
-p
/local/wheels
&&
\
chmod
g+rwX /opt/bitnami
COPY
rootfs /
COPY
*.whl *.tar.gz /local/wheels/
RUN
/opt/bitnami/scripts/airflow-worker/postunpack.sh
&&
\
source
/opt/bitnami/airflow/venv/bin/activate
&&
\
# Remove for security advisory GHSA-x9p2-fxq6-2m5f GHSA-4f9m-pxwh-68hg GHSA-388g-jwpg-x6j4
rm -rf ${BITNAMI_HOME}/airflow/venv/lib/python3.8/site-packages/swagger_ui_bundle/vendor/swagger-ui-2.2.10 && \
# Update to thrift-0.14 per CVE-2020-13949
tar xfz /local/wheels/thrift-0.14.1.tar.gz -C /local/wheels && \
pip install --no-index --no-deps /local/wheels/thrift-0.14.1/lib/py && \
rm -rf /local/wheels/thrift-0.14.1* && \
for f in $(ls -l /local/wheels | awk '{print $9}' |sed '/^$/d'); do pip install --no-index --no-deps /local/wheels/$f; done && \
find /opt/bitnami/airflow/venv/lib/python3.8/site-packages -name "*.pem" -o -name "*.key" | egrep ".*test.*/.*\.pem|.*test.*/.*\.key" | xargs rm -f && \
chmod +x /opt/bitnami/scripts/* && \
rm -rf /local/*
ENV
AIRFLOW_HOME="/opt/bitnami/airflow" \
BITNAMI_APP_NAME="airflow-worker" \
BITNAMI_IMAGE_VERSION="2.0.1-debian-10-r54" \
C_FORCE_ROOT="True" \
LANG="en_US.UTF-8" \
LANGUAGE="en_US:en" \
LD_LIBRARY_PATH="/opt/bitnami/python/lib/:/opt/bitnami/airflow/venv/lib/python3.8/site-packages/numpy.libs/:$LD_LIBRARY_PATH" \
LIBNSS_WRAPPER_PATH="/opt/bitnami/common/lib/libnss_wrapper.so" \
LNAME="airflow" \
NSS_WRAPPER_GROUP="/opt/bitnami/airflow/nss_group" \
NSS_WRAPPER_PASSWD="/opt/bitnami/airflow/nss_passwd" \
PATH="/opt/bitnami/common/bin:/opt/bitnami/python/bin:/opt/bitnami/postgresql/bin:/opt/bitnami/airflow/venv/bin:$PATH"
USER
1001
EXPOSE
8793
HEALTHCHECK
--start-period=10s CMD bash -c '</dev/tcp/127.0.0.1/8793 &>/dev/null' || exit 1
ENTRYPOINT
[ "/opt/bitnami/scripts/airflow-worker/entrypoint.sh" ]
CMD
[ "/opt/bitnami/scripts/airflow-worker/run.sh" ]
LICENSE
0 → 100644
View file @
72864b0e
Copyright (c) 2015-2021 Bitnami
Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at
http://www.apache.org/licenses/LICENSE-2.0
Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
README.md
View file @
72864b0e
This diff is collapsed.
Click to expand it.
hardening_manifest.yaml
0 → 100644
View file @
72864b0e
---
apiVersion
:
v1
# The repository name in registry1, excluding /ironbank/
name
:
"
bitnami/airflow-worker"
# List of tags to push for the repository in registry1
# The most specific version should be the first tag and will be shown
# on ironbank.dsop.io
tags
:
-
"
2.0.1"
# Build args passed to Dockerfile ARGs
args
:
BASE_IMAGE
:
"
redhat/ubi/ubi8"
BASE_TAG
:
"
8.3"
# Docker image labels
labels
:
org.opencontainers.image.title
:
"
airflow-worker"
## Human-readable description of the software packaged in the image
org.opencontainers.image.description
:
"
Apache
Airflow
is
a
tool
to
express
and
execute
workflows
as
directed
acyclic
graphs
(DAGs).
It
includes
utilities
to
schedule
tasks,
monitor
task
progress
and
handle
task
dependencies."
## License(s) under which contained software is distributed
org.opencontainers.image.licenses
:
"
Apache-2.0"
## URL to find more information on the image
org.opencontainers.image.url
:
"
https://airflow.apache.org"
## Name of the distributing entity, organization or individual
org.opencontainers.image.vendor
:
"
Bitnami"
org.opencontainers.image.version
:
"
2.0.1"
## Keywords to help with search (ex. "cicd,gitops,golang")
mil.dso.ironbank.image.keywords
:
"
workflows,dags,tasks"
## This value can be "opensource" or "commercial"
mil.dso.ironbank.image.type
:
"
opensource"
## Product the image belongs to for grouping multiple images
mil.dso.ironbank.product.name
:
"
Airflow"
# List of resources to make available to the offline build context
resources
:
-
tag
:
bitnami/airflow-worker:2.0.1-debian-10-r54
url
:
docker://docker.io/bitnami/airflow-worker@sha256:224ad64fbbf7cae7930fb3241b8e515499cde298cae639a4b037c0c3f8d8cd2c
-
filename
:
thrift-0.14.1.tar.gz
url
:
https://mirror.jframeworks.com/apache/thrift/0.14.1/thrift-0.14.1.tar.gz
validation
:
type
:
sha256
value
:
13da5e1cd9c8a3bb89778c0337cc57eb0c29b08f3090b41cf6ab78594b410ca5
-
filename
:
pylint-2.7.2-py3-none-any.whl
url
:
https://files.pythonhosted.org/packages/b3/66/af8f80d4fa77dcd4cba9e56e136522838920a2eaf6794b784e1f377f84d9/pylint-2.7.2-py3-none-any.whl
validation
:
type
:
sha256
value
:
d09b0b07ba06bcdff463958f53f23df25e740ecd81895f7d2699ec04bbd8dc3b
-
filename
:
networkx-2.5.1-py3-none-any.whl
url
:
https://files.pythonhosted.org/packages/f3/b7/c7f488101c0bb5e4178f3cde416004280fd40262433496830de8a8c21613/networkx-2.5.1-py3-none-any.whl
validation
:
type
:
sha256
value
:
0635858ed7e989f4c574c2328380b452df892ae85084144c73d8cd819f0c4e06
-
filename
:
decorator-4.4.2-py2.py3-none-any.whl
url
:
https://files.pythonhosted.org/packages/ed/1b/72a1821152d07cf1d8b6fce298aeb06a7eb90f4d6d41acec9861e7cc6df0/decorator-4.4.2-py2.py3-none-any.whl
validation
:
type
:
sha256
value
:
41fa54c2a0cc4ba648be4fd43cff00aedf5b9465c9bf18d64325bc225f08f760
-
filename
:
aiohttp-3.7.4.post0-cp38-cp38-manylinux2014_x86_64.whl
url
:
https://files.pythonhosted.org/packages/a6/76/f18138b0ff84fcd939667a2efc2e1b49c871299f9091f84c06bb4c350c01/aiohttp-3.7.4.post0-cp38-cp38-manylinux2014_x86_64.whl
validation
:
type
:
sha256
value
:
79ebfc238612123a713a457d92afb4096e2148be17df6c50fb9bf7a81c2f8013
-
filename
:
azure_storage_blob-12.8.0-py2.py3-none-any.whl
url
:
https://files.pythonhosted.org/packages/09/14/4ca417a9c92b0fb93516575dd7be9b058bf13d531dcc21239b5f8f216a69/azure_storage_blob-12.8.0-py2.py3-none-any.whl
validation
:
type
:
sha256
value
:
46999df6e2cde8773739f7c3bd1eb5846d4b7dc1ef6e2161f3b6d1d0f21726ba
# List of project maintainers
maintainers
:
-
name
:
"
Austin
Denton"
username
:
"
austindenton"
email
:
"
austindenton@seed-innovations.com"
cht_member
:
false
\ No newline at end of file
prebuildfs/opt/bitnami/.bitnami_components.json
0 → 100644
View file @
72864b0e
{
"airflow-worker"
:
{
"arch"
:
"amd64"
,
"digest"
:
"cf754bdc8e231d408275c1971d9a732576e346e0cd4af1ea426739bf3e62538d"
,
"distro"
:
"debian-10"
,
"type"
:
"NAMI"
,
"version"
:
"2.0.1-2"
},
"gosu"
:
{
"arch"
:
"amd64"
,
"digest"
:
"4d858ac600c38af8de454c27b7f65c0074ec3069880cb16d259a6e40a46bbc50"
,
"distro"
:
"debian-10"
,
"type"
:
"NAMI"
,
"version"
:
"1.12.0-2"
},
"ini-file"
:
{
"arch"
:
"amd64"
,
"digest"
:
"d89528e5d733f34ae030984584659ff10a36370d40332bd8d41c047764d39cda"
,
"distro"
:
"debian-10"
,
"type"
:
"NAMI"
,
"version"
:
"1.3.0-2"
},
"postgresql-client"
:
{
"arch"
:
"amd64"
,
"digest"
:
"6ae2df74c4cc145690104c9bfbd4f9977cc00d26b3a010bb1eba74d92048485d"
,
"distro"
:
"debian-10"
,
"type"
:
"NAMI"
,
"version"
:
"10.16.0-0"
},
"python"
:
{
"arch"
:
"amd64"
,
"digest"
:
"4f1f6b81a3617dfaaa2c579510118ef6df07119977a5d6ca7df3cf485fca709a"
,
"distro"
:
"debian-10"
,
"type"
:
"NAMI"
,
"version"
:
"3.8.9-0"
},
"wait-for-port"
:
{
"arch"
:
"amd64"
,
"digest"
:
"7521d9a4f9e4e182bf32977e234026caa7b03759799868335bccb1edd8f8fd12"
,
"distro"
:
"debian-10"
,
"type"
:
"NAMI"
,
"version"
:
"1.0.0-3"
}
}
\ No newline at end of file
prebuildfs/opt/bitnami/licenses/licenses.txt
0 → 100644
View file @
72864b0e
Bitnami containers ship with software bundles. You can find the licenses under:
/opt/bitnami/nami/COPYING
/opt/bitnami/[name-of-bundle]/licenses/[bundle-version].txt
prebuildfs/opt/bitnami/scripts/libbitnami.sh
0 → 100644
View file @
72864b0e
#!/bin/bash
#
# Bitnami custom library
# shellcheck disable=SC1091
# Load Generic Libraries
.
/opt/bitnami/scripts/liblog.sh
# Constants
BOLD
=
'\033[1m'
# Functions
########################
# Print the welcome page
# Globals:
# DISABLE_WELCOME_MESSAGE
# BITNAMI_APP_NAME
# Arguments:
# None
# Returns:
# None
#########################
print_welcome_page
()
{
if
[[
-z
"
${
DISABLE_WELCOME_MESSAGE
:-}
"
]]
;
then
if
[[
-n
"
$BITNAMI_APP_NAME
"
]]
;
then
print_image_welcome_page
fi
fi
}
########################
# Print the welcome page for a Bitnami Docker image
# Globals:
# BITNAMI_APP_NAME
# Arguments:
# None
# Returns:
# None
#########################
print_image_welcome_page
()
{
local
github_url
=
"https://github.com/bitnami/bitnami-docker-
${
BITNAMI_APP_NAME
}
"
log
""
log
"
${
BOLD
}
Welcome to the Bitnami
${
BITNAMI_APP_NAME
}
container
${
RESET
}
"
log
"Subscribe to project updates by watching
${
BOLD
}${
github_url
}${
RESET
}
"
log
"Submit issues and feature requests at
${
BOLD
}${
github_url
}
/issues
${
RESET
}
"
log
""
}
prebuildfs/opt/bitnami/scripts/libcomponent.sh
0 → 100644
View file @
72864b0e
#!/bin/bash
#
# Library for managing Bitnami components
# Constants
CACHE_ROOT
=
"/tmp/bitnami/pkg/cache"
DOWNLOAD_URL
=
"https://downloads.bitnami.com/files/stacksmith"
# Functions
########################
# Download and unpack a Bitnami package
# Globals:
# OS_NAME
# OS_ARCH
# OS_FLAVOUR
# Arguments:
# $1 - component's name
# $2 - component's version
# Returns:
# None
#########################
component_unpack
()
{
local
name
=
"
${
1
:?name
is required
}
"
local
version
=
"
${
2
:?version
is required
}
"
local
base_name
=
"
${
name
}
-
${
version
}
-
${
OS_NAME
}
-
${
OS_ARCH
}
-
${
OS_FLAVOUR
}
"
local
package_sha256
=
""
local
directory
=
"/opt/bitnami"
# Validate arguments
shift
2
while
[
"$#"
-gt
0
]
;
do
case
"
$1
"
in
-c
|
--checksum
)
shift
package_sha256
=
"
${
1
:?missing
package checksum
}
"
;;
*
)
echo
"Invalid command line flag
$1
"
>
&2
return
1
;;
esac
shift
done
echo
"Downloading
$base_name
package"
if
[
-f
"
${
CACHE_ROOT
}
/
${
base_name
}
.tar.gz"
]
;
then
echo
"
${
CACHE_ROOT
}
/
${
base_name
}
.tar.gz already exists, skipping download."
cp
"
${
CACHE_ROOT
}
/
${
base_name
}
.tar.gz"
.
rm
"
${
CACHE_ROOT
}
/
${
base_name
}
.tar.gz"
if
[
-f
"
${
CACHE_ROOT
}
/
${
base_name
}
.tar.gz.sha256"
]
;
then
echo
"Using the local sha256 from
${
CACHE_ROOT
}
/
${
base_name
}
.tar.gz.sha256"
package_sha256
=
"
$(
<
"
${
CACHE_ROOT
}
/
${
base_name
}
.tar.gz.sha256"
)
"
rm
"
${
CACHE_ROOT
}
/
${
base_name
}
.tar.gz.sha256"
fi
else
curl
--remote-name
--silent
"
${
DOWNLOAD_URL
}
/
${
base_name
}
.tar.gz"
fi
if
[
-n
"
$package_sha256
"
]
;
then
echo
"Verifying package integrity"
echo
"
$package_sha256
${
base_name
}
.tar.gz"
|
sha256sum
--check
-
fi
tar
--directory
"
${
directory
}
"
--extract
--gunzip
--file
"
${
base_name
}
.tar.gz"
--no-same-owner
--strip-components
=
2
"
${
base_name
}
/files/"
rm
"
${
base_name
}
.tar.gz"
}
prebuildfs/opt/bitnami/scripts/libfile.sh
0 → 100644
View file @
72864b0e
#!/bin/bash
#
# Library for managing files
# Functions
########################
# Replace a regex in a file
# Arguments:
# $1 - filename
# $2 - match regex
# $3 - substitute regex
# $4 - use POSIX regex. Default: true
# Returns:
# None
#########################
replace_in_file
()
{
local
filename
=
"
${
1
:?filename
is required
}
"
local
match_regex
=
"
${
2
:?match
regex is required
}
"
local
substitute_regex
=
"
${
3
:?substitute
regex is required
}
"
local
posix_regex
=
${
4
:-
true
}
local
result
# We should avoid using 'sed in-place' substitutions
# 1) They are not compatible with files mounted from ConfigMap(s)
# 2) We found incompatibility issues with Debian10 and "in-place" substitutions
del
=
$'
\0
01'
# Use a non-printable character as a 'sed' delimiter to avoid issues
if
[[
$posix_regex
=
true
]]
;
then
result
=
"
$(
sed
-E
"s
${
del
}${
match_regex
}${
del
}${
substitute_regex
}${
del
}
g"
"
$filename
"
)
"
else
result
=
"
$(
sed
"s
${
del
}${
match_regex
}${
del
}${
substitute_regex
}${
del
}
g"
"
$filename
"
)
"
fi
echo
"
$result
"
>
"
$filename
"
}
########################
# Remove a line in a file based on a regex
# Arguments:
# $1 - filename
# $2 - match regex
# $3 - use POSIX regex. Default: true
# Returns:
# None
#########################
remove_in_file
()
{
local
filename
=
"
${
1
:?filename
is required
}
"
local
match_regex
=
"
${
2
:?match
regex is required
}
"
local
posix_regex
=
${
3
:-
true
}
local
result
# We should avoid using 'sed in-place' substitutions
# 1) They are not compatible with files mounted from ConfigMap(s)
# 2) We found incompatibility issues with Debian10 and "in-place" substitutions
if
[[
$posix_regex
=
true
]]
;
then
result
=
"
$(
sed
-E
"/
$match_regex
/d"
"
$filename
"
)
"
else
result
=
"
$(
sed
"/
$match_regex
/d"
"
$filename
"
)
"
fi
echo
"
$result
"
>
"
$filename
"
}
########################
# Appends text after the last line matching a pattern
# Arguments:
# $1 - file
# $2 - match regex
# $3 - contents to add
# Returns:
# None
#########################
append_file_after_last_match
()
{
local
file
=
"
${
1
:?missing
file
}
"
local
match_regex
=
"
${
2
:?missing
pattern
}
"
local
value
=
"
${
3
:?missing
value
}
"
# We read the file in reverse, replace the first match (0,/pattern/s) and then reverse the results again
result
=
"
$(
tac
"
$file
"
|
sed
-E
"0,/(
$match_regex
)/s||
${
value
}
\n\1
|"
|
tac
)
"
echo
"
$result
"
>
"
$file
"
}
prebuildfs/opt/bitnami/scripts/libfs.sh
0 → 100644
View file @
72864b0e
#!/bin/bash
#
# Library for file system actions
# shellcheck disable=SC1091
# Load Generic Libraries
.
/opt/bitnami/scripts/liblog.sh
# Functions
########################
# Ensure a file/directory is owned (user and group) but the given user
# Arguments:
# $1 - filepath
# $2 - owner
# Returns:
# None
#########################
owned_by
()
{
local
path
=
"
${
1
:?path
is missing
}
"
local
owner
=
"
${
2
:?owner
is missing
}
"
chown
"
$owner
"
:
"
$owner
"
"
$path
"
}
########################
# Ensure a directory exists and, optionally, is owned by the given user
# Arguments:
# $1 - directory
# $2 - owner
# Returns:
# None
#########################
ensure_dir_exists
()
{
local dir
=
"
${
1
:?directory
is missing
}
"
local
owner
=
"
${
2
:-}
"
mkdir
-p
"
${
dir
}
"
if
[[
-n
$owner
]]
;
then
owned_by
"
$dir
"
"
$owner
"
fi
}
########################
# Checks whether a directory is empty or not
# arguments:
# $1 - directory
# returns:
# boolean
#########################
is_dir_empty
()
{
local dir
=
"
${
1
:?missing
directory
}
"
if
[[
!
-e
"
$dir
"
]]
||
[[
-z
"
$(
ls
-A
"
$dir
"
)
"
]]
;
then
true
else
false
fi
}
########################
# Checks whether a mounted directory is empty or not
# arguments:
# $1 - directory
# returns:
# boolean
#########################
is_mounted_dir_empty
()
{
local dir
=
"
${
1
:?missing
directory
}
"
if
is_dir_empty
"
$dir
"
||
find
"
$dir
"
-mindepth
1
-maxdepth
1
-not
-name
".snapshot"
-not
-name
"lost+found"
-exec
false
{}
+
;
then
true
else
false
fi
}
########################
# Checks whether a file can be written to or not
# arguments:
# $1 - file
# returns:
# boolean
#########################
is_file_writable
()
{
local
file
=
"
${
1
:?missing
file
}
"
local dir
dir
=
"
$(
dirname
"
$file
"
)
"
if
[[
(
-f
"
$file
"
&&
-w
"
$file
"
)
||
(
!
-f
"
$file
"
&&
-d
"
$dir
"
&&
-w
"
$dir
"
)
]]
;
then
true
else
false
fi
}
########################
# Relativize a path
# arguments:
# $1 - path
# $2 - base
# returns:
# None
#########################
relativize
()
{
local
-r
path
=
"
${
1
:?missing
path
}
"
local
-r
base
=
"
${
2
:?missing
base
}
"
pushd
"
$base
"
>
/dev/null
||
exit
realpath
-q
--no-symlinks
--relative-base
=
"
$base
"
"
$path
"
|
sed
-e
's|^/$|.|'
-e
's|^/||'
popd
>
/dev/null
||
exit
}
########################
# Configure permisions and ownership recursively
# Globals:
# None
# Arguments:
# $1 - paths (as a string).
# Flags:
# -f|--file-mode - mode for directories.
# -d|--dir-mode - mode for files.
# -u|--user - user
# -g|--group - group
# Returns:
# None
#########################
configure_permissions_ownership
()
{
local
-r
paths
=
"
${
1
:?paths
is missing
}
"
local
dir_mode
=
""
local
file_mode
=
""
local
user
=
""
local
group
=
""
# Validate arguments
shift
1
while
[
"$#"
-gt
0
]
;
do
case
"
$1
"
in
-f
|
--file-mode
)
shift
file_mode
=
"
${
1
:?missing
mode for files
}
"
;;
-d
|
--dir-mode
)
shift
dir_mode
=
"
${
1
:?missing
mode for directories
}
"
;;
-u
|
--user
)
shift
user
=
"
${
1
:?missing
user
}
"
;;
-g
|
--group
)
shift
group
=
"
${
1
:?missing
group
}
"
;;
*
)
echo
"Invalid command line flag
$1
"
>
&2
return
1
;;
esac
shift
done
read
-r
-a
filepaths
<<<
"
$paths
"
for
p
in
"
${
filepaths
[@]
}
"
;
do
if
[[
-e
"
$p
"
]]
;
then
if
[[
-n
$dir_mode
]]
;
then
find
-L
"
$p
"
-type
d
-exec
chmod
"
$dir_mode
"
{}
\;
fi
if
[[
-n
$file_mode
]]
;
then
find
-L
"
$p
"
-type
f
-exec
chmod
"
$file_mode
"
{}
\;
fi
if
[[
-n
$user
]]
&&
[[
-n
$group
]]
;
then
chown
-LR
"
$user
"
:
"
$group
"
"
$p
"
elif
[[
-n
$user
]]
&&
[[
-z
$group
]]
;
then
chown
-LR
"
$user
"
"
$p
"
elif
[[
-z
$user
]]
&&
[[
-n
$group
]]
;
then
chgrp
-LR
"
$group
"
"
$p
"
fi
else
stderr_print
"
$p
does not exist"
fi
done
}
prebuildfs/opt/bitnami/scripts/libhook.sh
0 → 100644
View file @
72864b0e
#!/bin/bash
#
# Library to use for scripts expected to be used as Kubernetes lifecycle hooks
# shellcheck disable=SC1091
# Load generic libraries
.
/opt/bitnami/scripts/liblog.sh
.
/opt/bitnami/scripts/libos.sh
# Override functions that log to stdout/stderr of the current process, so they print to process 1
for
function_to_override
in
stderr_print debug_execute
;
do
# Output is sent to output of process 1 and thus end up in the container log
# The hook output in general isn't saved
eval
"
$(
declare
-f
"
$function_to_override
"
)
>/proc/1/fd/1 2>/proc/1/fd/2"
done
prebuildfs/opt/bitnami/scripts/liblog.sh
0 → 100644
View file @
72864b0e
#!/bin/bash
#
# Library for logging functions
# Constants
RESET
=
'\033[0m'
RED
=
'\033[38;5;1m'
GREEN
=
'\033[38;5;2m'
YELLOW
=
'\033[38;5;3m'
MAGENTA
=
'\033[38;5;5m'
CYAN
=
'\033[38;5;6m'
# Functions
########################
# Print to STDERR
# Arguments:
# Message to print
# Returns:
# None
#########################
stderr_print
()
{
# 'is_boolean_yes' is defined in libvalidations.sh, but depends on this file so we cannot source it
local
bool
=
"
${
BITNAMI_QUIET
:-
false
}
"
# comparison is performed without regard to the case of alphabetic characters
shopt
-s
nocasematch
if
!
[[
"
$bool
"
=
1
||
"
$bool
"
=
~ ^
(
yes
|true
)
$
]]
;
then
printf
"%b
\\
n"
"
${
*
}
"
>
&2
fi
}
########################
# Log message
# Arguments:
# Message to log
# Returns:
# None
#########################
log
()
{
stderr_print
"
${
CYAN
}${
MODULE
:-}
${
MAGENTA
}
$(
date
"+%T.%2N "
)
${
RESET
}${
*
}
"
}
########################
# Log an 'info' message
# Arguments:
# Message to log
# Returns:
# None
#########################
info
()
{
log
"
${
GREEN
}
INFO
${
RESET
}
==>
${
*
}
"
}
########################
# Log message
# Arguments:
# Message to log
# Returns:
# None
#########################
warn
()
{
log
"
${
YELLOW
}
WARN
${
RESET
}
==>
${
*
}
"
}
########################
# Log an 'error' message
# Arguments:
# Message to log
# Returns:
# None
#########################
error
()
{
log
"
${
RED
}
ERROR
${
RESET
}
==>
${
*
}
"
}
########################
# Log a 'debug' message
# Globals:
# BITNAMI_DEBUG
# Arguments:
# None
# Returns:
# None
#########################
debug
()
{
# 'is_boolean_yes' is defined in libvalidations.sh, but depends on this file so we cannot source it
local
bool
=
"
${
BITNAMI_DEBUG
:-
false
}
"
# comparison is performed without regard to the case of alphabetic characters
shopt
-s
nocasematch
if
[[
"
$bool
"
=
1
||
"
$bool
"
=
~ ^
(
yes
|true
)
$
]]
;
then
log
"
${
MAGENTA
}
DEBUG
${
RESET
}
==>
${
*
}
"
fi
}
########################
# Indent a string
# Arguments:
# $1 - string
# $2 - number of indentation characters (default: 4)
# $3 - indentation character (default: " ")
# Returns:
# None
#########################
indent
()
{
local
string
=
"
${
1
:-}
"
local
num
=
"
${
2
:?missing
num
}
"
local
char
=
"
${
3
:-
" "
}
"
# Build the indentation unit string
local
indent_unit
=
""
for
((
i
=
0
;
i < num
;
i++
))
;
do
indent_unit
=
"
${
indent_unit
}${
char
}
"
done
# shellcheck disable=SC2001
# Complex regex, see https://github.com/koalaman/shellcheck/wiki/SC2001#exceptions
echo
"
$string
"
|
sed
"s/^/
${
indent_unit
}
/"
}
prebuildfs/opt/bitnami/scripts/libnet.sh
0 → 100644
View file @
72864b0e
#!/bin/bash
#
# Library for network functions
# shellcheck disable=SC1091
# Load Generic Libraries
.
/opt/bitnami/scripts/liblog.sh
# Functions
########################
# Resolve IP address for a host/domain (i.e. DNS lookup)
# Arguments:
# $1 - Hostname to resolve
# $2 - IP address version (v4, v6), leave empty for resolving to any version
# Returns:
# IP
#########################
dns_lookup
()
{
local
host
=
"
${
1
:?host
is missing
}
"
local
ip_version
=
"
${
2
:-}
"
getent
"ahosts
${
ip_version
}
"
"
$host
"
|
awk
'/STREAM/ {print $1 }'
|
head
-n
1
}
#########################
# Wait for a hostname and return the IP
# Arguments:
# $1 - hostname
# $2 - number of retries
# $3 - seconds to wait between retries
# Returns:
# - IP address that corresponds to the hostname
#########################
wait_for_dns_lookup
()
{
local hostname
=
"
${
1
:?hostname
is missing
}
"
local
retries
=
"
${
2
:-
5
}
"
local
seconds
=
"
${
3
:-
1
}
"
check_host
()
{
if
[[
$(
dns_lookup
"
$hostname
"
)
==
""
]]
;
then
false
else
true
fi
}
# Wait for the host to be ready
retry_while
"check_host
${
hostname
}
"
"
$retries
"
"
$seconds
"
dns_lookup
"
$hostname
"
}
########################
# Get machine's IP
# Arguments:
# None
# Returns:
# Machine IP
#########################
get_machine_ip
()
{
local
-a
ip_addresses
local hostname
hostname
=
"
$(
hostname
)
"
read
-r
-a
ip_addresses
<<<
"
$(
dns_lookup
"
$hostname
"
| xargs
echo
)
"
if
[[
"
${#
ip_addresses
[@]
}
"
-gt
1
]]
;
then
warn
"Found more than one IP address associated to hostname
${
hostname
}
:
${
ip_addresses
[*]
}
, will use
${
ip_addresses
[0]
}
"
elif
[[
"
${#
ip_addresses
[@]
}
"
-lt
1
]]
;
then
error
"Could not find any IP address associated to hostname
${
hostname
}
"
exit
1
fi
echo
"
${
ip_addresses
[0]
}
"
}
########################
# Check if the provided argument is a resolved hostname
# Arguments:
# $1 - Value to check
# Returns:
# Boolean
#########################
is_hostname_resolved
()
{
local
-r
host
=
"
${
1
:?missing
value
}
"
if
[[
-n
"
$(
dns_lookup
"
$host
"
)
"
]]
;
then
true
else
false
fi
}
########################
# Parse URL
# Globals:
# None
# Arguments:
# $1 - uri - String
# $2 - component to obtain. Valid options (scheme, authority, userinfo, host, port, path, query or fragment) - String
# Returns:
# String
parse_uri
()
{
local
uri
=
"
${
1
:?uri
is missing
}
"
local
component
=
"
${
2
:?component
is missing
}
"
# Solution based on https://tools.ietf.org/html/rfc3986#appendix-B with
# additional sub-expressions to split authority into userinfo, host and port
# Credits to Patryk Obara (see https://stackoverflow.com/a/45977232/6694969)
local
-r
URI_REGEX
=
'^(([^:/?#]+):)?(//((([^@/?#]+)@)?([^:/?#]+)(:([0-9]+))?))?(/([^?#]*))?(\?([^#]*))?(#(.*))?'
# || | ||| | | | | | | | | |
# |2 scheme | ||6 userinfo 7 host | 9 port | 11 rpath | 13 query | 15 fragment
# 1 scheme: | |5 userinfo@ 8 :... 10 path 12 ?... 14 #...
# | 4 authority
# 3 //...
local
index
=
0
case
"
$component
"
in
scheme
)
index
=
2
;;
authority
)
index
=
4
;;
userinfo
)
index
=
6
;;
host
)
index
=
7
;;
port
)
index
=
9
;;
path
)
index
=
10
;;
query
)
index
=
13
;;
fragment
)
index
=
14
;;
*
)
stderr_print
"unrecognized component
$component
"
return
1
;;
esac
[[
"
$uri
"
=
~
$URI_REGEX
]]
&&
echo
"
${
BASH_REMATCH
[
${
index
}
]
}
"
}
prebuildfs/opt/bitnami/scripts/libos.sh
0 → 100644
View file @
72864b0e
#!/bin/bash
#
# Library for operating system actions
# shellcheck disable=SC1091
# Load Generic Libraries
.
/opt/bitnami/scripts/liblog.sh
.
/opt/bitnami/scripts/libfs.sh
# Functions
########################
# Check if an user exists in the system
# Arguments:
# $1 - user
# Returns:
# Boolean
#########################
user_exists
()
{
local
user
=
"
${
1
:?user
is missing
}
"
id
"
$user
"
>
/dev/null 2>&1
}
########################
# Check if a group exists in the system
# Arguments:
# $1 - group
# Returns:
# Boolean
#########################
group_exists
()
{
local
group
=
"
${
1
:?group
is missing
}
"
getent group
"
$group
"
>
/dev/null 2>&1
}
########################
# Create a group in the system if it does not exist already
# Arguments:
# $1 - group
# Flags:
# -s|--system - Whether to create new user as system user (uid <= 999)
# Returns:
# None
#########################
ensure_group_exists
()
{
local
group
=
"
${
1
:?group
is missing
}
"
local
is_system_user
=
false
# Validate arguments
shift
1
while
[
"$#"
-gt
0
]
;
do
case
"
$1
"
in
-s
|
--system
)
is_system_user
=
true
;;
*
)
echo
"Invalid command line flag
$1
"
>
&2
return
1
;;
esac
shift
done
if
!
group_exists
"
$group
"
;
then
local
-a
args
=(
"
$group
"
)
$is_system_user
&&
args+
=(
"--system"
)
groupadd
"
${
args
[@]
}
"
>
/dev/null 2>&1
fi
}
########################
# Create an user in the system if it does not exist already
# Arguments:
# $1 - user
# Flags:
# -g|--group - the group the new user should belong to
# -h|--home - the home directory for the new user
# -s|--system - whether to create new user as system user (uid <= 999)
# Returns:
# None
#########################
ensure_user_exists
()
{
local
user
=
"
${
1
:?user
is missing
}
"
local
group
=
""
local
home
=
""
local
is_system_user
=
false
# Validate arguments
shift
1
while
[
"$#"
-gt
0
]
;
do
case
"
$1
"
in
-g
|
--group
)
shift
group
=
"
${
1
:?missing
group
}
"
;;
-h
|
--home
)
shift
home
=
"
${
1
:?missing
home directory
}
"
;;
-s
|
--system
)
is_system_user
=
true
;;
*
)
echo
"Invalid command line flag
$1
"
>
&2
return
1
;;
esac
shift
done
if
!
user_exists
"
$user
"
;
then
local
-a
user_args
=(
"-N"
"
$user
"
)
$is_system_user
&&
user_args+
=(
"--system"
)
useradd
"
${
user_args
[@]
}
"
>
/dev/null 2>&1
fi
if
[[
-n
"
$group
"
]]
;
then
local
-a
group_args
=(
"
$group
"
)
$is_system_user
&&
group_args+
=(
"--system"
)
ensure_group_exists
"
${
group_args
[@]
}
"
usermod
-g
"
$group
"
"
$user
"
>
/dev/null 2>&1
fi
if
[[
-n
"
$home
"
]]
;
then
mkdir
-p
"
$home
"
usermod
-d
"
$home
"
"
$user
"
>
/dev/null 2>&1
configure_permissions_ownership
"
$home
"
-d
"775"
-f
"664"
-u
"
$user
"
-g
"
$group
"
fi
}
########################
# Check if the script is currently running as root
# Arguments:
# $1 - user
# $2 - group
# Returns:
# Boolean
#########################
am_i_root
()
{
if
[[
"
$(
id
-u
)
"
=
"0"
]]
;
then
true
else
false
fi
}
########################
# Get total memory available
# Arguments:
# None
# Returns:
# Memory in bytes
#########################
get_total_memory
()
{
echo
$((
$(
grep
MemTotal /proc/meminfo |
awk
'{print $2}'
)
/
1024
))
}
########################
# Get machine size depending on specified memory
# Globals:
# None
# Arguments:
# None
# Flags:
# --memory - memory size (optional)
# Returns:
# Detected instance size
#########################
get_machine_size
()
{
local
memory
=
""
# Validate arguments
while
[[
"$#"
-gt
0
]]
;
do
case
"
$1
"
in
--memory
)
shift
memory
=
"
${
1
:?missing
memory
}
"
;;
*
)
echo
"Invalid command line flag
$1
"
>
&2
return
1
;;
esac
shift
done
if
[[
-z
"
$memory
"
]]
;
then
debug
"Memory was not specified, detecting available memory automatically"
memory
=
"
$(
get_total_memory
)
"
fi
sanitized_memory
=
$(
convert_to_mb
"
$memory
"
)
if
[[
"
$sanitized_memory
"
-gt
26000
]]
;
then
echo
2xlarge
elif
[[
"
$sanitized_memory
"
-gt
13000
]]
;
then
echo
xlarge
elif
[[
"
$sanitized_memory
"
-gt
6000
]]
;
then
echo
large
elif
[[
"
$sanitized_memory
"
-gt
3000
]]
;
then
echo
medium
elif
[[
"
$sanitized_memory
"
-gt
1500
]]
;
then
echo
small
else
echo
micro
fi
}
########################
# Get machine size depending on specified memory
# Globals:
# None
# Arguments:
# $1 - memory size (optional)
# Returns:
# Detected instance size
#########################
get_supported_machine_sizes
()
{
echo
micro small medium large xlarge 2xlarge
}
########################
# Convert memory size from string to amount of megabytes (i.e. 2G -> 2048)
# Globals:
# None
# Arguments:
# $1 - memory size
# Returns:
# Result of the conversion
#########################
convert_to_mb
()
{
local
amount
=
"
${
1
:-}
"
if
[[
$amount
=
~ ^
([
0-9]+
)(
m|M|g|G
)
]]
;
then
size
=
"
${
BASH_REMATCH
[1]
}
"
unit
=
"
${
BASH_REMATCH
[2]
}
"
if
[[
"
$unit
"
=
"g"
||
"
$unit
"
=
"G"
]]
;
then
amount
=
"
$((
size
*
1024
))
"
else
amount
=
"
$size
"
fi
fi
echo
"
$amount
"
}
#########################
# Redirects output to /dev/null if debug mode is disabled
# Globals:
# BITNAMI_DEBUG
# Arguments:
# $@ - Command to execute
# Returns:
# None
#########################
debug_execute
()
{
if
${
BITNAMI_DEBUG
:-
false
}
;
then
"
$@
"
else
"
$@
"
>
/dev/null 2>&1
fi
}
########################
# Retries a command a given number of times
# Arguments:
# $1 - cmd (as a string)
# $2 - max retries. Default: 12
# $3 - sleep between retries (in seconds). Default: 5
# Returns:
# Boolean
#########################
retry_while
()
{
local
cmd
=
"
${
1
:?cmd
is missing
}
"
local
retries
=
"
${
2
:-
12
}
"
local
sleep_time
=
"
${
3
:-
5
}
"
local
return_value
=
1
read
-r
-a
command
<<<
"
$cmd
"
for
((
i
=
1
;
i <
=
retries
;
i+
=
1
))
;
do
"
${
command
[@]
}
"
&&
return_value
=
0
&&
break
sleep
"
$sleep_time
"
done
return
$return_value
}
########################
# Generate a random string
# Arguments:
# -t|--type - String type (ascii, alphanumeric, numeric), defaults to ascii
# -c|--count - Number of characters, defaults to 32
# Arguments:
# None
# Returns:
# None
# Returns:
# String
#########################
generate_random_string
()
{
local type
=
"ascii"
local
count
=
"32"
local
filter
local
result
# Validate arguments
while
[[
"$#"
-gt
0
]]
;
do
case
"
$1
"
in
-t
|
--type
)
shift
type
=
"
$1
"
;;
-c
|
--count
)
shift
count
=
"
$1
"
;;
*
)
echo
"Invalid command line flag
$1
"
>
&2
return
1
;;
esac
shift
done
# Validate type
case
"
$type
"
in
ascii
)
filter
=
"[:print:]"
;;
alphanumeric
)
filter
=
"a-zA-Z0-9"
;;
numeric
)
filter
=
"0-9"
;;
*
)
echo
"Invalid type
${
type
}
"
>
&2
return
1
esac
# Obtain count + 10 lines from /dev/urandom to ensure that the resulting string has the expected size
# Note there is a very small chance of strings starting with EOL character
# Therefore, the higher amount of lines read, this will happen less frequently
result
=
"
$(
head
-n
"
$((
count
+
10
))
"
/dev/urandom |
tr
-dc
"
$filter
"
|
head
-c
"
$count
"
)
"
echo
"
$result
"
}
########################
# Create md5 hash from a string
# Arguments:
# $1 - string
# Returns:
# md5 hash - string
#########################
generate_md5_hash
()
{
local
-r
str
=
"
${
1
:?missing
input string
}
"
echo
-n
"
$str
"
|
md5sum
|
awk
'{print $1}'
}
prebuildfs/opt/bitnami/scripts/libpersistence.sh
0 → 100644
View file @
72864b0e
#!/bin/bash
#
# Bitnami persistence library
# Used for bringing persistence capabilities to applications that don't have clear separation of data and logic
# shellcheck disable=SC1091
# Load Generic Libraries
.
/opt/bitnami/scripts/libfs.sh
.
/opt/bitnami/scripts/libos.sh
.
/opt/bitnami/scripts/liblog.sh
.
/opt/bitnami/scripts/libversion.sh
# Functions
########################
# Persist an application directory
# Globals:
# BITNAMI_ROOT_DIR
# BITNAMI_VOLUME_DIR
# Arguments:
# $1 - App folder name
# $2 - List of app files to persist
# Returns:
# true if all steps succeeded, false otherwise
#########################
persist_app
()
{
local
-r
app
=
"
${
1
:?missing
app
}
"
local
-a
files_to_restore
read
-r
-a
files_to_persist
<<<
"
$2
"
local
-r
install_dir
=
"
${
BITNAMI_ROOT_DIR
}
/
${
app
}
"
local
-r
persist_dir
=
"
${
BITNAMI_VOLUME_DIR
}
/
${
app
}
"
# Persist the individual files
if
[[
"
${#
files_to_persist
[@]
}
"
-lt
0
]]
;
then
warn
"No files are configured to be persisted"
return
fi
pushd
"
$install_dir
"
>
/dev/null
||
exit
local
file_to_persist_relative file_to_persist_destination file_to_persist_destination_folder
local
-r
tmp_file
=
"/tmp/perms.acl"
for
file_to_persist
in
"
${
files_to_persist
[@]
}
"
;
do
if
[[
!
-f
"
$file_to_persist
"
&&
!
-d
"
$file_to_persist
"
]]
;
then
error
"Cannot persist '
${
file_to_persist
}
' because it does not exist"
return
1
fi
file_to_persist_relative
=
"
$(
relativize
"
$file_to_persist
"
"
$install_dir
"
)
"
file_to_persist_destination
=
"
${
persist_dir
}
/
${
file_to_persist_relative
}
"
file_to_persist_destination_folder
=
"
$(
dirname
"
$file_to_persist_destination
"
)
"
# Get original permissions for existing files, which will be applied later
# Exclude the root directory with 'sed', to avoid issues when copying the entirety of it to a volume
getfacl
-R
"
$file_to_persist_relative
"
|
sed
-E
'/# file: (\..+|[^.])/,$!d'
>
"
$tmp_file
"
# Copy directories to the volume
ensure_dir_exists
"
$file_to_persist_destination_folder
"
cp
-Lr
--preserve
=
links
"
$file_to_persist_relative
"
"
$file_to_persist_destination_folder
"
# Restore permissions
pushd
"
$persist_dir
"
>
/dev/null
||
exit
if
am_i_root
;
then
setfacl
--restore
=
"
$tmp_file
"
else
# When running as non-root, don't change ownership
setfacl
--restore
=
<
(
grep
-E
-v
'^# (owner|group):'
"
$tmp_file
"
)
fi
popd
>
/dev/null
||
exit
done
popd
>
/dev/null
||
exit
rm
-f
"
$tmp_file
"
# Install the persisted files into the installation directory, via symlinks
restore_persisted_app
"
$@
"
}
########################
# Restore a persisted application directory
# Globals:
# BITNAMI_ROOT_DIR
# BITNAMI_VOLUME_DIR
# FORCE_MAJOR_UPGRADE
# Arguments:
# $1 - App folder name
# $2 - List of app files to restore
# Returns:
# true if all steps succeeded, false otherwise
#########################
restore_persisted_app
()
{
local
-r
app
=
"
${
1
:?missing
app
}
"
local
-a
files_to_restore
read
-r
-a
files_to_restore
<<<
"
$2
"
local
-r
install_dir
=
"
${
BITNAMI_ROOT_DIR
}
/
${
app
}
"
local
-r
persist_dir
=
"
${
BITNAMI_VOLUME_DIR
}
/
${
app
}
"
# Restore the individual persisted files
if
[[
"
${#
files_to_restore
[@]
}
"
-lt
0
]]
;
then
warn
"No persisted files are configured to be restored"
return
fi
local
file_to_restore_relative file_to_restore_origin file_to_restore_destination
for
file_to_restore
in
"
${
files_to_restore
[@]
}
"
;
do
file_to_restore_relative
=
"
$(
relativize
"
$file_to_restore
"
"
$install_dir
"
)
"
# We use 'realpath --no-symlinks' to ensure that the case of '.' is covered and the directory is removed
file_to_restore_origin
=
"
$(
realpath
--no-symlinks
"
${
install_dir
}
/
${
file_to_restore_relative
}
"
)
"
file_to_restore_destination
=
"
$(
realpath
--no-symlinks
"
${
persist_dir
}
/
${
file_to_restore_relative
}
"
)
"
rm
-rf
"
$file_to_restore_origin
"
ln
-sfn
"
$file_to_restore_destination
"
"
$file_to_restore_origin
"
done
}
########################
# Check if an application directory was already persisted
# Globals:
# BITNAMI_VOLUME_DIR
# Arguments:
# $1 - App folder name
# Returns:
# true if all steps succeeded, false otherwise
#########################
is_app_initialized
()
{
local
-r
app
=
"
${
1
:?missing
app
}
"
local
-r
persist_dir
=
"
${
BITNAMI_VOLUME_DIR
}
/
${
app
}
"
if
!
is_mounted_dir_empty
"
$persist_dir
"
;
then
true
else
false
fi
}
prebuildfs/opt/bitnami/scripts/libservice.sh
0 → 100644
View file @
72864b0e
#!/bin/bash
#
# Library for managing services
# shellcheck disable=SC1091
# Load Generic Libraries
.
/opt/bitnami/scripts/libvalidations.sh
.
/opt/bitnami/scripts/liblog.sh
# Functions
########################
# Read the provided pid file and returns a PID
# Arguments:
# $1 - Pid file
# Returns:
# PID
#########################
get_pid_from_file
()
{
local
pid_file
=
"
${
1
:?pid
file is missing
}
"
if
[[
-f
"
$pid_file
"
]]
;
then
if
[[
-n
"
$(
<
"
$pid_file
"
)
"
]]
&&
[[
"
$(
<
"
$pid_file
"
)
"
-gt
0
]]
;
then
echo
"
$(
<
"
$pid_file
"
)
"
fi
fi
}
########################
# Check if a provided PID corresponds to a running service
# Arguments:
# $1 - PID
# Returns:
# Boolean
#########################
is_service_running
()
{
local
pid
=
"
${
1
:?pid
is missing
}
"
kill
-0
"
$pid
"
2>/dev/null
}
########################
# Stop a service by sending a termination signal to its pid
# Arguments:
# $1 - Pid file
# $2 - Signal number (optional)
# Returns:
# None
#########################
stop_service_using_pid
()
{
local
pid_file
=
"
${
1
:?pid
file is missing
}
"
local
signal
=
"
${
2
:-}
"
local
pid
pid
=
"
$(
get_pid_from_file
"
$pid_file
"
)
"
[[
-z
"
$pid
"
]]
||
!
is_service_running
"
$pid
"
&&
return
if
[[
-n
"
$signal
"
]]
;
then
kill
"-
${
signal
}
"
"
$pid
"
else
kill
"
$pid
"
fi
local
counter
=
10
while
[[
"
$counter
"
-ne
0
]]
&&
is_service_running
"
$pid
"
;
do
sleep
1
counter
=
$((
counter
-
1
))
done
}
########################
# Start cron daemon
# Arguments:
# None
# Returns:
# true if started correctly, false otherwise
#########################
cron_start
()
{
if
[[
-x
"/usr/sbin/cron"
]]
;
then
/usr/sbin/cron
elif
[[
-x
"/usr/sbin/crond"
]]
;
then
/usr/sbin/crond
else
false
fi
}
########################
# Generate a cron configuration file for a given service
# Arguments:
# $1 - Service name
# $2 - Command
# Flags:
# --run-as - User to run as (default: root)
# --schedule - Cron schedule configuration (default: * * * * *)
# Returns:
# None
#########################
generate_cron_conf
()
{
local
service_name
=
"
${
1
:?service
name is missing
}
"
local
cmd
=
"
${
2
:?command
is missing
}
"
local
run_as
=
"root"
local
schedule
=
"* * * * *"
local
clean
=
"true"
local
clean
=
"true"
# Parse optional CLI flags
shift
2
while
[[
"$#"
-gt
0
]]
;
do
case
"
$1
"
in
--run-as
)
shift
run_as
=
"
$1
"
;;
--schedule
)
shift
schedule
=
"
$1
"
;;
--no-clean
)
clean
=
"false"
;;
*
)
echo
"Invalid command line flag
${
1
}
"
>
&2
return
1
;;
esac
shift
done
mkdir
-p
/etc/cron.d
if
"
$clean
"
;
then
echo
"
${
schedule
}
${
run_as
}
${
cmd
}
"
>
/etc/cron.d/
"
$service_name
"
else
echo
"
${
schedule
}
${
run_as
}
${
cmd
}
"
>>
/etc/cron.d/
"
$service_name
"
fi
}
########################
# Generate a monit configuration file for a given service
# Arguments:
# $1 - Service name
# $2 - Pid file
# $3 - Start command
# $4 - Stop command
# Flags:
# --disabled - Whether to disable the monit configuration
# Returns:
# None
#########################
generate_monit_conf
()
{
local
service_name
=
"
${
1
:?service
name is missing
}
"
local
pid_file
=
"
${
2
:?pid
file is missing
}
"
local
start_command
=
"
${
3
:?start
command is missing
}
"
local
stop_command
=
"
${
4
:?stop
command is missing
}
"
local
monit_conf_dir
=
"/etc/monit/conf.d"
local
disabled
=
"no"
# Parse optional CLI flags
shift
4
while
[[
"$#"
-gt
0
]]
;
do
case
"
$1
"
in
--disabled
)
shift
disabled
=
"
$1
"
;;
*
)
echo
"Invalid command line flag
${
1
}
"
>
&2
return
1
;;
esac
shift
done
is_boolean_yes
"
$disabled
"
&&
conf_suffix
=
".disabled"
mkdir
-p
"
$monit_conf_dir
"
cat
>
"
${
monit_conf_dir
}
/
${
service_name
}
.conf
${
conf_suffix
:-}
"
<<
EOF
check process
${
service_name
}
with pidfile "
${
pid_file
}
"
start program = "
${
start_command
}
" with timeout 90 seconds
stop program = "
${
stop_command
}
" with timeout 90 seconds
EOF
}
########################
# Generate a logrotate configuration file
# Arguments:
# $1 - Service name
# $2 - Log files pattern
# Flags:
# --period - Period
# --rotations - Number of rotations to store
# --extra - Extra options (Optional)
# Returns:
# None
#########################
generate_logrotate_conf
()
{
local
service_name
=
"
${
1
:?service
name is missing
}
"
local
log_path
=
"
${
2
:?log
path is missing
}
"
local
period
=
"weekly"
local
rotations
=
"150"
local
extra
=
""
local
logrotate_conf_dir
=
"/etc/logrotate.d"
local
var_name
# Parse optional CLI flags
shift
2
while
[[
"$#"
-gt
0
]]
;
do
case
"
$1
"
in
--period
|
--rotations
|
--extra
)
var_name
=
"
$(
echo
"
$1
"
|
sed
-e
"s/^--//"
-e
"s/-/_/g"
)
"
shift
declare
"
$var_name
"
=
"
${
1
:?
"
$var_name
"
is missing
}
"
;;
*
)
echo
"Invalid command line flag
${
1
}
"
>
&2
return
1
;;
esac
shift
done
mkdir
-p
"
$logrotate_conf_dir
"
cat
<<
EOF
| sed '/^
\s
*
$/
d' >"
${
logrotate_conf_dir
}
/
${
service_name
}
"
${
log_path
}
{
${
period
}
rotate
${
rotations
}
dateext
compress
copytruncate
missingok
$(
indent
"
$extra
"
2
)
}
EOF
}
prebuildfs/opt/bitnami/scripts/libvalidations.sh
0 → 100644
View file @
72864b0e
#!/bin/bash
#
# Validation functions library
# shellcheck disable=SC1091
# Load Generic Libraries
.
/opt/bitnami/scripts/liblog.sh
# Functions
########################
# Check if the provided argument is an integer
# Arguments:
# $1 - Value to check
# Returns:
# Boolean
#########################
is_int
()
{
local
-r
int
=
"
${
1
:?missing
value
}
"
if
[[
"
$int
"
=
~ ^-?[0-9]+
]]
;
then
true
else
false
fi
}
########################
# Check if the provided argument is a positive integer
# Arguments:
# $1 - Value to check
# Returns:
# Boolean
#########################
is_positive_int
()
{
local
-r
int
=
"
${
1
:?missing
value
}
"
if
is_int
"
$int
"
&&
((
"
${
int
}
"
>=
0
))
;
then
true
else
false
fi
}
########################
# Check if the provided argument is a boolean or is the string 'yes/true'
# Arguments:
# $1 - Value to check
# Returns:
# Boolean
#########################
is_boolean_yes
()
{
local
-r
bool
=
"
${
1
:-}
"
# comparison is performed without regard to the case of alphabetic characters
shopt
-s
nocasematch
if
[[
"
$bool
"
=
1
||
"
$bool
"
=
~ ^
(
yes
|true
)
$
]]
;
then
true
else
false
fi
}
########################
# Check if the provided argument is a boolean yes/no value
# Arguments:
# $1 - Value to check
# Returns:
# Boolean
#########################
is_yes_no_value
()
{
local
-r
bool
=
"
${
1
:-}
"
if
[[
"
$bool
"
=
~ ^
(
yes
|no
)
$
]]
;
then
true
else
false
fi
}
########################
# Check if the provided argument is a boolean true/false value
# Arguments:
# $1 - Value to check
# Returns:
# Boolean
#########################
is_true_false_value
()
{
local
-r
bool
=
"
${
1
:-}
"
if
[[
"
$bool
"
=
~ ^
(
true
|false
)
$
]]
;
then
true
else
false
fi
}
########################
# Check if the provided argument is an empty string or not defined
# Arguments:
# $1 - Value to check
# Returns:
# Boolean
#########################
is_empty_value
()
{
local
-r
val
=
"
${
1
:-}
"
if
[[
-z
"
$val
"
]]
;
then
true
else
false
fi
}
########################
# Validate if the provided argument is a valid port
# Arguments:
# $1 - Port to validate
# Returns:
# Boolean and error message
#########################
validate_port
()
{
local
value
local
unprivileged
=
0
# Parse flags
while
[[
"$#"
-gt
0
]]
;
do
case
"
$1
"
in
-unprivileged
)
unprivileged
=
1
;;
--
)
shift
break
;;
-
*
)
stderr_print
"unrecognized flag
$1
"
return
1
;;
*
)
break
;;
esac
shift
done
if
[[
"$#"
-gt
1
]]
;
then
echo
"too many arguments provided"
return
2
elif
[[
"$#"
-eq
0
]]
;
then
stderr_print
"missing port argument"
return
1
else
value
=
$1
fi
if
[[
-z
"
$value
"
]]
;
then
echo
"the value is empty"
return
1
else
if
!
is_int
"
$value
"
;
then
echo
"value is not an integer"
return
2
elif
[[
"
$value
"
-lt
0
]]
;
then
echo
"negative value provided"
return
2
elif
[[
"
$value
"
-gt
65535
]]
;
then
echo
"requested port is greater than 65535"
return
2
elif
[[
"
$unprivileged
"
=
1
&&
"
$value
"
-lt
1024
]]
;
then
echo
"privileged port requested"
return
3
fi
fi
}
########################
# Validate if the provided argument is a valid IPv4 address
# Arguments:
# $1 - IP to validate
# Returns:
# Boolean
#########################
validate_ipv4
()
{
local
ip
=
"
${
1
:?ip
is missing
}
"
local stat
=
1
if
[[
$ip
=
~ ^[0-9]
{
1,3
}
\.
[
0-9]
{
1,3
}
\.
[
0-9]
{
1,3
}
\.
[
0-9]
{
1,3
}
$
]]
;
then
read
-r
-a
ip_array
<<<
"
$(
tr
'.'
' '
<<<
"
$ip
"
)
"
[[
${
ip_array
[0]
}
-le
255
&&
${
ip_array
[1]
}
-le
255
\
&&
${
ip_array
[2]
}
-le
255
&&
${
ip_array
[3]
}
-le
255
]]
stat
=
$?
fi
return
$stat
}
########################
# Validate a string format
# Arguments:
# $1 - String to validate
# Returns:
# Boolean
#########################
validate_string
()
{
local
string
local
min_length
=
-1
local
max_length
=
-1
# Parse flags
while
[
"$#"
-gt
0
]
;
do
case
"
$1
"
in
-min-length
)
shift
min_length
=
${
1
:-}
;;
-max-length
)
shift
max_length
=
${
1
:-}
;;
--
)
shift
break
;;
-
*
)
stderr_print
"unrecognized flag
$1
"
return
1
;;
*
)
break
;;
esac
shift
done
if
[
"$#"
-gt
1
]
;
then
stderr_print
"too many arguments provided"
return
2
elif
[
"$#"
-eq
0
]
;
then
stderr_print
"missing string"
return
1
else
string
=
$1
fi
if
[[
"
$min_length
"
-ge
0
]]
&&
[[
"
${#
string
}
"
-lt
"
$min_length
"
]]
;
then
echo
"string length is less than
$min_length
"
return
1
fi
if
[[
"
$max_length
"
-ge
0
]]
&&
[[
"
${#
string
}
"
-gt
"
$max_length
"
]]
;
then
echo
"string length is great than
$max_length
"
return
1
fi
}
prebuildfs/opt/bitnami/scripts/libversion.sh
0 → 100644
View file @
72864b0e
#!/bin/bash
#
# Library for managing versions strings
# shellcheck disable=SC1091
# Load Generic Libraries
.
/opt/bitnami/scripts/liblog.sh
# Functions
########################
# Gets semantic version
# Arguments:
# $1 - version: string to extract major.minor.patch
# $2 - section: 1 to extract major, 2 to extract minor, 3 to extract patch
# Returns:
# array with the major, minor and release
#########################
get_sematic_version
()
{
local
version
=
"
${
1
:?version
is required
}
"
local
section
=
"
${
2
:?section
is required
}
"
local
-a
version_sections
#Regex to parse versions: x.y.z
local
-r
regex
=
'([0-9]+)(\.([0-9]+)(\.([0-9]+))?)?'
if
[[
"
$version
"
=
~
$regex
]]
;
then
local
i
=
1
local
j
=
1
local
n
=
${#
BASH_REMATCH
[*]
}
while
[[
$i
-lt
$n
]]
;
do
if
[[
-n
"
${
BASH_REMATCH
[
$i
]
}
"
]]
&&
[[
"
${
BASH_REMATCH
[
$i
]
:0:1
}
"
!=
'.'
]]
;
then
version_sections[
$j
]=
${
BASH_REMATCH
[
$i
]
}
((
j++
))
fi
((
i++
))
done
local
number_regex
=
'^[0-9]+$'
if
[[
"
$section
"
=
~
$number_regex
]]
&&
((
section
>
0
))
&&
((
section <
=
3
))
;
then
echo
"
${
version_sections
[
$section
]
}
"
return
else
stderr_print
"Section allowed values are: 1, 2, and 3"
return
1
fi
fi
}
prebuildfs/opt/bitnami/scripts/libwebserver.sh
0 → 100644
View file @
72864b0e
#!/bin/bash
#
# Bitnami web server handler library
# shellcheck disable=SC1090,SC1091
# Load generic libraries
.
/opt/bitnami/scripts/liblog.sh
########################
# Execute a command (or list of commands) with the web server environment and library loaded
# Globals:
# *
# Arguments:
# None
# Returns:
# None
#########################
web_server_execute
()
{
local
-r
web_server
=
"
${
1
:?missing
web server
}
"
shift
# Run program in sub-shell to avoid web server environment getting loaded when not necessary
(
.
"/opt/bitnami/scripts/lib
${
web_server
}
.sh"
.
"/opt/bitnami/scripts/
${
web_server
}
-env.sh"
"
$@
"
)
}
########################
# Prints the list of enabled web servers
# Globals:
# None
# Arguments:
# None
# Returns:
# None
#########################
web_server_list
()
{
local
-r
-a
supported_web_servers
=(
apache nginx
)
local
-a
existing_web_servers
=()
for
web_server
in
"
${
supported_web_servers
[@]
}
"
;
do
[[
-f
"/opt/bitnami/scripts/
${
web_server
}
-env.sh"
]]
&&
existing_web_servers+
=(
"
$web_server
"
)
done
echo
"
${
existing_web_servers
[@]
:-}
"
}
########################
# Prints the currently-enabled web server type (only one, in order of preference)
# Globals:
# None
# Arguments:
# None
# Returns:
# None
#########################
web_server_type
()
{
local
-a
web_servers
read
-r
-a
web_servers
<<<
"
$(
web_server_list
)
"
echo
"
${
web_servers
[0]
:-}
"
}
########################
# Validate that a supported web server is configured
# Globals:
# None
# Arguments:
# None
# Returns:
# None
#########################
web_server_validate
()
{
local
error_code
=
0
local
supported_web_servers
=(
"apache"
"nginx"
)
# Auxiliary functions
print_validation_error
()
{
error
"
$1
"
error_code
=
1
}
if
[[
-z
"
$(
web_server_type
)
"
||
!
"
${
supported_web_servers
[*]
}
"
==
*
"
$(
web_server_type
)
"
*
]]
;
then
print_validation_error
"Could not detect any supported web servers. It must be one of:
${
supported_web_servers
[*]
}
"
elif
!
web_server_execute
"
$(
web_server_type
)
"
type
-t
"is_
$(
web_server_type
)
_running"
>
/dev/null
;
then
print_validation_error
"Could not load the
$(
web_server_type
)
web server library from /opt/bitnami/scripts. Check that it exists and is readable."
fi
return
"
$error_code
"
}
########################
# Check whether the web server is running
# Globals:
# *
# Arguments:
# None
# Returns:
# true if the web server is running, false otherwise
#########################
is_web_server_running
()
{
"is_
$(
web_server_type
)
_running"
}
########################
# Start web server
# Globals:
# *
# Arguments:
# None
# Returns:
# None
#########################
web_server_start
()
{
info
"Starting
$(
web_server_type
)
in background"
"
${
BITNAMI_ROOT_DIR
}
/scripts/
$(
web_server_type
)
/start.sh"
}
########################
# Stop web server
# Globals:
# *
# Arguments:
# None
# Returns:
# None
#########################
web_server_stop
()
{
info
"Stopping
$(
web_server_type
)
"
"
${
BITNAMI_ROOT_DIR
}
/scripts/
$(
web_server_type
)
/stop.sh"
}
########################
# Restart web server
# Globals:
# *
# Arguments:
# None
# Returns:
# None
#########################
web_server_restart
()
{
info
"Restarting
$(
web_server_type
)
"
"
${
BITNAMI_ROOT_DIR
}
/scripts/
$(
web_server_type
)
/restart.sh"
}
########################
# Reload web server
# Globals:
# *
# Arguments:
# None
# Returns:
# None
#########################
web_server_reload
()
{
"
${
BITNAMI_ROOT_DIR
}
/scripts/
$(
web_server_type
)
/reload.sh"
}
########################
# Ensure a web server application configuration exists (i.e. Apache virtual host format or NGINX server block)
# It serves as a wrapper for the specific web server function
# Globals:
# *
# Arguments:
# $1 - App name
# Flags:
# --hosts - Hosts to enable
# --type - Application type, which has an effect on which configuration template to use
# --allow-remote-connections - Whether to allow remote connections or to require local connections
# --disabled - Whether to render the file with a .disabled prefix
# --enable-https - Enable app configuration on HTTPS port
# --http-port - HTTP port number
# --https-port - HTTPS port number
# --document-root - Path to document root directory
# Apache-specific flags:
# --apache-additional-configuration - Additional vhost configuration (no default)
# --apache-before-vhost-configuration - Configuration to add before the <VirtualHost> directive (no default)
# --apache-allow-override - Whether to allow .htaccess files (only allowed when --move-htaccess is set to 'no')
# --apache-extra-directory-configuration - Extra configuration for the document root directory
# --apache-move-htaccess - Move .htaccess files to a common place so they can be loaded during Apache startup
# NGINX-specific flags:
# --nginx-additional-configuration - Additional server block configuration (no default)
# Returns:
# true if the configuration was enabled, false otherwise
########################
ensure_web_server_app_configuration_exists
()
{
local
app
=
"
${
1
:?missing
app
}
"
shift
local
-a
apache_args nginx_args web_servers args_var
apache_args
=(
"
$app
"
)
nginx_args
=(
"
$app
"
)
# Validate arguments
while
[[
"$#"
-gt
0
]]
;
do
case
"
$1
"
in
# Common flags
--hosts
\
|
--type
\
|
--allow-remote-connections
\
|
--disabled
\
|
--enable-https
\
|
--http-port
\
|
--https-port
\
|
--document-root
\
)
apache_args+
=(
"
$1
"
"
${
2
:?missing
value
}
"
)
nginx_args+
=(
"
$1
"
"
${
2
:?missing
value
}
"
)
shift
;;
# Specific Apache flags
--apache-additional-configuration
\
|
--apache-before-vhost-configuration
\
|
--apache-allow-override
\
|
--apache-extra-directory-configuration
\
|
--apache-move-htaccess
\
)
apache_args+
=(
"
${
1
//apache-/
}
"
"
${
2
:?missing
value
}
"
)
shift
;;
# Specific NGINX flags
--nginx-additional-configuration
)
nginx_args+
=(
"
${
1
//nginx-/
}
"
"
${
2
:?missing
value
}
"
)
shift
;;
*
)
echo
"Invalid command line flag
$1
"
>
&2
return
1
;;
esac
shift
done
read
-r
-a
web_servers
<<<
"
$(
web_server_list
)
"
for
web_server
in
"
${
web_servers
[@]
}
"
;
do
args_var
=
"
${
web_server
}
_args[@]"
web_server_execute
"
$web_server
"
"ensure_
${
web_server
}
_app_configuration_exists"
"
${
!args_var
}
"
done
}
########################
# Ensure a web server application configuration does not exist anymore (i.e. Apache virtual host format or NGINX server block)
# It serves as a wrapper for the specific web server function
# Globals:
# *
# Arguments:
# $1 - App name
# Returns:
# true if the configuration was disabled, false otherwise
########################
ensure_web_server_app_configuration_not_exists
()
{
local
app
=
"
${
1
:?missing
app
}
"
local
-a
web_servers
read
-r
-a
web_servers
<<<
"
$(
web_server_list
)
"
for
web_server
in
"
${
web_servers
[@]
}
"
;
do
web_server_execute
"
$web_server
"
"ensure_
${
web_server
}
_app_configuration_not_exists"
"
$app
"
done
}
########################
# Ensure the web server loads the configuration for an application in a URL prefix
# It serves as a wrapper for the specific web server function
# Globals:
# *
# Arguments:
# $1 - App name
# Flags:
# --allow-remote-connections - Whether to allow remote connections or to require local connections
# --document-root - Path to document root directory
# --prefix - URL prefix from where it will be accessible (i.e. /myapp)
# --type - Application type, which has an effect on what configuration template will be used
# Apache-specific flags:
# --apache-additional-configuration - Additional vhost configuration (no default)
# --apache-allow-override - Whether to allow .htaccess files (only allowed when --move-htaccess is set to 'no')
# --apache-extra-directory-configuration - Extra configuration for the document root directory
# --apache-move-htaccess - Move .htaccess files to a common place so they can be loaded during Apache startup
# NGINX-specific flags:
# --nginx-additional-configuration - Additional server block configuration (no default)
# Returns:
# true if the configuration was enabled, false otherwise
########################
ensure_web_server_prefix_configuration_exists
()
{
local
app
=
"
${
1
:?missing
app
}
"
shift
local
-a
apache_args nginx_args web_servers args_var
apache_args
=(
"
$app
"
)
nginx_args
=(
"
$app
"
)
# Validate arguments
while
[[
"$#"
-gt
0
]]
;
do
case
"
$1
"
in
# Common flags
--allow-remote-connections
\
|
--document-root
\
|
--prefix
\
|
--type
\
)
apache_args+
=(
"
$1
"
"
${
2
:?missing
value
}
"
)
nginx_args+
=(
"
$1
"
"
${
2
:?missing
value
}
"
)
shift
;;
# Specific Apache flags
--apache-additional-configuration
\
|
--apache-allow-override
\
|
--apache-extra-directory-configuration
\
|
--apache-move-htaccess
\
)
apache_args+
=(
"
${
1
//apache-/
}
"
"
$2
"
)
shift
;;
# Specific NGINX flags
--nginx-additional-configuration
)
nginx_args+
=(
"
${
1
//nginx-/
}
"
"
$2
"
)
shift
;;
*
)
echo
"Invalid command line flag
$1
"
>
&2
return
1
;;
esac
shift
done
read
-r
-a
web_servers
<<<
"
$(
web_server_list
)
"
for
web_server
in
"
${
web_servers
[@]
}
"
;
do
args_var
=
"
${
web_server
}
_args[@]"
web_server_execute
"
$web_server
"
"ensure_
${
web_server
}
_prefix_configuration_exists"
"
${
!args_var
}
"
done
}
########################
# Ensure a web server application configuration is updated with the runtime configuration (i.e. ports)
# It serves as a wrapper for the specific web server function
# Globals:
# *
# Arguments:
# $1 - App name
# Flags:
# --hosts - Hosts to enable
# --enable-https - Update HTTPS app configuration
# --http-port - HTTP port number
# --https-port - HTTPS port number
# Returns:
# true if the configuration was updated, false otherwise
########################
web_server_update_app_configuration
()
{
local
app
=
"
${
1
:?missing
app
}
"
shift
local
-a
args web_servers
args
=(
"
$app
"
)
# Validate arguments
while
[[
"$#"
-gt
0
]]
;
do
case
"
$1
"
in
# Common flags
--hosts
\
|
--enable-https
\
|
--http-port
\
|
--https-port
\
)
args+
=(
"
$1
"
"
${
2
:?missing
value
}
"
)
shift
;;
*
)
echo
"Invalid command line flag
$1
"
>
&2
return
1
;;
esac
shift
done
read
-r
-a
web_servers
<<<
"
$(
web_server_list
)
"
for
web_server
in
"
${
web_servers
[@]
}
"
;
do
web_server_execute
"
$web_server
"
"
${
web_server
}
_update_app_configuration"
"
${
args
[@]
}
"
done
}
########################
# Enable loading page, which shows users that the initialization process is not yet completed
# Globals:
# *
# Arguments:
# None
# Returns:
# None
#########################
web_server_enable_loading_page
()
{
ensure_web_server_app_configuration_exists
"__loading"
--hosts
"_default_"
\
--apache-additional-configuration
"
# Show a HTTP 503 Service Unavailable page by default
RedirectMatch 503 ^/
$
# Show index.html if server is answering with 404 Not Found or 503 Service Unavailable status codes
ErrorDocument 404 /index.html
ErrorDocument 503 /index.html"
\
--nginx-additional-configuration
"
# Show a HTTP 503 Service Unavailable page by default
location / {
return 503;
}
# Show index.html if server is answering with 404 Not Found or 503 Service Unavailable status codes
error_page 404 @installing;
error_page 503 @installing;
location @installing {
rewrite ^(.*)
$
/index.html break;
}"
web_server_reload
}
########################
# Enable loading page, which shows users that the initialization process is not yet completed
# Globals:
# *
# Arguments:
# None
# Returns:
# None
#########################
web_server_disable_install_page
()
{
ensure_web_server_app_configuration_not_exists
"__loading"
web_server_reload
}
prebuildfs/usr/sbin/install_packages
0 → 100755
View file @
72864b0e
#!/bin/sh
set
-e
set
-u
export
DEBIAN_FRONTEND
=
noninteractive
n
=
0
max
=
2
until
[
$n
-gt
$max
]
;
do
set
+e
(
apt-get update
-qq
&&
apt-get
install
-y
--no-install-recommends
"
$@
"
)
CODE
=
$?
set
-e
if
[
$CODE
-eq
0
]
;
then
break
fi
if
[
$n
-eq
$max
]
;
then
exit
$CODE
fi
echo
"apt failed, retrying"
n
=
$((
$n
+
1
))
done
rm
-r
/var/lib/apt/lists /var/cache/apt/archives
Prev
1
2
Next
Write
Preview
Markdown
is supported
0%
Try again
or
attach a new file
.
Attach a file
Cancel
You are about to add
0
people
to the discussion. Proceed with caution.
Finish editing this message first!
Cancel
Please
register
or
sign in
to comment